Index: trunk/sources/HeuristicLab.TestFunctions/AckleyEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/AckleyEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/AckleyEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Ackley Function<br/>
+  /// Domain:  [-32.768 , 32.768]^n <br/>
+  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// </summary>
   public class AckleyEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Ackley function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 20 + Math.E;
@@ -58,4 +69,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Ackley function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/BealeEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/BealeEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/BealeEvaluator.cs	(revision 1188)
@@ -24,6 +24,12 @@
 using System.Text;
 
-namespace HeuristicLab.TestFunctions {   
+namespace HeuristicLab.TestFunctions { 
+  /// <summary>
+  /// Beale Function<br/>
+  /// Domain:  [-4.5 , 4.5]^2<br/>
+  /// Optimum: 0.0 at (3.0, 0.5)
+  /// </summary>
   public class BealeEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -35,8 +41,19 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Beale function at the given point.</returns>
     public static double Apply(double[] point) {
       return Math.Pow(1.5 - point[0] * (1 - point[1]), 2) + Math.Pow(2.25 - point[0] * (1 - (point[1] * point[1])), 2) + Math.Pow((2.625 - point[0] * (1 - (point[1] * point[1] * point[1]))), 2);
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Beale function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/BoothEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/BoothEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/BoothEvaluator.cs	(revision 1188)
@@ -25,5 +25,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Booth Function<br/>
+  /// Domain:  [-10.0 , 10.0]^2<br/>
+  /// Optimum: 0.0 at (1.0, 3.0)
+  /// </summary>
   public class BoothEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get {
@@ -36,8 +42,19 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Booth function at the given point.</returns>
     public static double Apply(double[] point) {
       return Math.Pow(point[0] + 2 * point[1] - 7, 2) + Math.Pow(2 * point[0] + point[1] - 5, 2);
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Booth function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/GriewangkEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/GriewangkEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/GriewangkEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Griewangk Function<br/>
+  /// Domain:  [-600.0 , 600.0]^n<br/>
+  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// </summary>
   public class GriewangkEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Griewangk function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 0;
@@ -54,4 +65,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Griewangk function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/HeuristicLabTestFunctionsPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/HeuristicLabTestFunctionsPlugin.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/HeuristicLabTestFunctionsPlugin.cs	(revision 1188)
@@ -26,4 +26,7 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Plugin class for HeuristicLab.TestFunctions plugin.
+  /// </summary>
   [ClassInfo(Name = "HeuristicLab.TestFunctions-3.2")]
   [PluginFile(Filename = "HeuristicLab.TestFunctions-3.2.dll", Filetype = PluginFileType.Assembly)]
Index: trunk/sources/HeuristicLab.TestFunctions/LevyEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/LevyEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/LevyEvaluator.cs	(revision 1188)
@@ -25,5 +25,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Levy Function<br/>
+  /// Domain:  [-10.0 , 10.0]^n<br/>
+  /// Optimum: 0.0 at (1.0, 1.0, ..., 1.0)
+  /// </summary>
   public class LevyEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -35,4 +41,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Levy function at the given point.</returns>
     public static double Apply(double[] point) {
       int length = point.Length;
@@ -53,4 +64,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Levy function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/MatyasEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/MatyasEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/MatyasEvaluator.cs	(revision 1188)
@@ -25,5 +25,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Matyas Function<br/>
+  /// Domain:  [-10.0 , 10.0]^2<br/>
+  /// Optimum: 0.0 at (0.0, 0.0)
+  /// </summary>
   public class MatyasEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -35,8 +41,19 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Matyas function at the given point.</returns>
     public static double Apply(double[] point) {
       return 0.26 * (point[0] * point[0] + point[1] * point[1]) - 0.48 * point[0] * point[1];
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Matyas function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/RastriginEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/RastriginEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/RastriginEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Rastrigin Function<br/>
+  /// Domain:  [-5.12 , 5.12]^n<br/>
+  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// </summary>
   public class RastriginEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Rastrigin function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 10 * point.Length;
@@ -47,4 +58,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Rastrigin function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/RosenbrockEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/RosenbrockEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/RosenbrockEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Rosenbrock Function<br/>
+  /// Domain:  [-2.048 , 2.048]^n<br/>
+  /// Optimum: 0.0 at (1, 1, ..., 1)
+  /// </summary>
   public class RosenbrockEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Rosenbrock function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 0;
@@ -47,4 +58,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Rosenbrock function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/SchwefelEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/SchwefelEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/SchwefelEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Schwefel Function (Sine Root)<br/>
+  /// Domain:  [-500.0 , 500.0]^n<br/>
+  /// Optimum: 0.0 at (420.968746453712, 420.968746453712, ..., 420.968746453712)
+  /// </summary>
   public class SchwefelEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Schwefel function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 418.982887272433 * point.Length;
@@ -45,4 +56,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Schwefel function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/SphereEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/SphereEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/SphereEvaluator.cs	(revision 1188)
@@ -28,5 +28,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Sphere Function<br/>
+  /// Domain:  [-5.12 , 5.12]^n<br/>
+  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// </summary>
   public class SphereEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -38,4 +44,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Sphere function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 0;
@@ -45,4 +56,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Sphere function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/SumSquaresEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/SumSquaresEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/SumSquaresEvaluator.cs	(revision 1188)
@@ -25,5 +25,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Sum Squares Function<br/>
+  /// Domain:  [-10.0 , 10.0]^n<br/>
+  /// Optimum: 0.0 at (0.0, 0.0, ..., 0.0)
+  /// </summary>
   public class SumSquaresEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -35,4 +41,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Sum Squares function at the given point.</returns>
     public static double Apply(double[] point) {
       double result = 0;
@@ -43,4 +54,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Sum Squares function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionEvaluatorBase.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionEvaluatorBase.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionEvaluatorBase.cs	(revision 1188)
@@ -28,13 +28,31 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Base class for a test function evaluator.
+  /// </summary>
   public abstract class TestFunctionEvaluatorBase : SingleObjectiveEvaluatorBase {
+    /// <summary>
+    /// Initializes a new instance of <see cref="TestFunctionEvaluatorBase"/> with one variable info
+    /// (<c>Point</c>).
+    /// </summary>
     public TestFunctionEvaluatorBase() {
       AddVariableInfo(new VariableInfo("Point", "n-dimensional point for which the test function should be evaluated", typeof(DoubleArrayData), VariableKind.In));
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific point.
+    /// </summary>
+    /// <remarks>Calls <see cref="EvaluateFunction(double[])"/>.</remarks>
+    /// <param name="scope">The current scope with the point for which to evaluate.</param>
+    /// <returns>The result value of the function at the given point.</returns>
     protected sealed override double Evaluate(IScope scope) {
       return EvaluateFunction(GetVariableValue<DoubleArrayData>("Point", scope, false).Data);
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the function at the given point.</returns>
     protected abstract double EvaluateFunction(double[] point);
   }
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 1188)
@@ -27,5 +27,9 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Injects the necessary variables for optimizing a test function
+  /// </summary>
   public class TestFunctionInjector : OperatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get {
@@ -34,4 +38,7 @@
     }
 
+    /// <summary>
+    /// Gets or sets the boolean flag whether it is an optimization problem or not.
+    /// </summary>
     public bool Maximization {
       get { return GetVariable("Maximization").GetValue<BoolData>().Data; }
@@ -39,4 +46,7 @@
     }
 
+    /// <summary>
+    /// Gets or sets the lower bound.
+    /// </summary>
     public double LowerBound {
       get { return GetVariable("LowerBound").GetValue<DoubleData>().Data; }
@@ -44,4 +54,7 @@
     }
 
+    /// <summary>
+    /// Gets or sets the upper bound.
+    /// </summary>
     public double UpperBound {
       get { return GetVariable("UpperBound").GetValue<DoubleData>().Data; }
@@ -49,4 +62,7 @@
     }
 
+    /// <summary>
+    /// Gets or sets the dimension.
+    /// </summary>
     public int Dimension {
       get { return GetVariable("Dimension").GetValue<IntData>().Data; }
@@ -54,4 +70,8 @@
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="TestFunctionInjector"/> with four variable infos
+    /// (<c>Maximization</c>, <c>LowerBound</c>, <c>UpperBound</c> and <c>Dimension</c>).
+    /// </summary>
     public TestFunctionInjector()
       : base() {
@@ -62,4 +82,9 @@
     }
 
+    /// <summary>
+    /// Injects the necessary variables for optimizing a test function.
+    /// </summary>
+    /// <param name="scope">The scope where to inject the variables.</param>
+    /// <returns><c>null</c>.</returns>
     public override IOperation Apply(IScope scope) {
       scope.AddVariable((IVariable)GetVariable("Maximization").Clone());
@@ -70,4 +95,9 @@
     }
 
+    /// <summary>
+    /// Creates a new instance of <see cref="TestFunctionInjectorView"/> to represent the current 
+    /// instance visually.
+    /// </summary>
+    /// <returns>The newly created view as <see cref="TestFunctionInjectorView"/>.</returns>
     public override IView CreateView() {
       return new TestFunctionInjectorView(this);
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 1188)
@@ -32,5 +32,13 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Visual representation of a <see cref="TestFunctionInjector"/>.
+  /// </summary>
   public partial class TestFunctionInjectorView : ViewBase {
+    /// <summary>
+    /// Gets or sets the TestFunctionInjector to represent visually.
+    /// </summary>
+    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
+    /// No own data storage present.</remarks>
     public TestFunctionInjector TestFunctionInjector {
       get { return (TestFunctionInjector)base.Item; }
@@ -38,8 +46,16 @@
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="TestFunctionInjectorView"/>.
+    /// </summary>
     public TestFunctionInjectorView() {
       InitializeComponent();
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="TestFunctionInjectorView"/> with the given
+    /// <paramref name="testFunctionInjector"/> to display.
+    /// </summary>
+    /// <param name="testFunctionInjector">The injector to represent visually.</param>
     public TestFunctionInjectorView(TestFunctionInjector testFunctionInjector)
       : this() {
@@ -47,4 +63,9 @@
     }
 
+    /// <summary>
+    /// Removes the eventhandler from the underlying controls.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.
+    /// </remarks>
     protected override void RemoveItemEvents() {
       maximizationCheckBox.DataBindings.Clear();
@@ -55,4 +76,9 @@
     }
 
+    /// <summary>
+    /// Adds eventhandlers to the underlying controls.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.
+    /// </remarks>
     protected override void AddItemEvents() {
       base.AddItemEvents();
@@ -63,4 +89,8 @@
     }
 
+    /// <summary>
+    /// Updates all controls with the latest values.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.UpdateControls"/> of base class <see cref="ViewBase"/>.</remarks>
     protected override void UpdateControls() {
       base.UpdateControls();
Index: trunk/sources/HeuristicLab.TestFunctions/ZakharovEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/ZakharovEvaluator.cs	(revision 1187)
+++ trunk/sources/HeuristicLab.TestFunctions/ZakharovEvaluator.cs	(revision 1188)
@@ -25,5 +25,11 @@
 
 namespace HeuristicLab.TestFunctions {
+  /// <summary>
+  /// Zakharov Function<br/>
+  /// Domain:  [-5.0 , 10.0]^n<br/>
+  /// Optimum: 0.0 at (0.0, 0.0, ..., 0.0)
+  /// </summary>
   public class ZakharovEvaluator : TestFunctionEvaluatorBase {
+    /// <inheritdoc select="summary"/>
     public override string Description {
       get { return
@@ -35,4 +41,9 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Zakharov function at the given point.</returns>
     public static double Apply(double[] point) {
       int length = point.Length;
@@ -47,4 +58,10 @@
     }
 
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Zakharov function at the given point.</returns>
     protected override double EvaluateFunction(double[] point) {
       return Apply(point);